--- old/usr/src/cmd/man/man.c	Tue Jul 15 19:41:38 2014
+++ new/usr/src/cmd/man/man.c	Tue Jul 15 19:41:38 2014
@@ -159,6 +159,7 @@
 static int	sargs = 0;
 static int	psoutput = 0;
 static int	whatis = 0;
+static int	makewhatishere = 0;
 
 static char	*mansec;
 static char	*pager;
@@ -191,6 +192,8 @@
 static char	**split(char *, char);
 static void	usage_man(void);
 static void	usage_whatapro(void);
+static void	usage_catman(void);
+static void	usage_makewhatis(void);
 static void	whatapro(struct man_node *, char *);
 
 static char	language[MAXPATHLEN]; 	/* LC_MESSAGES */
@@ -213,6 +216,7 @@
 	int		ret = 0;
 	char		*opts;
 	char		*mwstr;
+	int		catman = 0;
 
 	(void) setlocale(LC_ALL, "");
 	(void) strcpy(language, setlocale(LC_MESSAGES, (char *)NULL));
@@ -231,6 +235,15 @@
 		apropos++;
 		whatis++;
 		opts = "M:ds:";
+	} else if (strcmp(__progname, "catman") == 0) {
+		catman++;
+		makewhatis++;
+		opts = "M:w";
+	} else if (strcmp(__progname, "makewhatis") == 0) {
+		makewhatis++;
+		makewhatishere++;
+		manpath = ".";
+		opts = "";
 	} else {
 		opts = "M:adfklps:tw";
 	}
@@ -273,6 +286,10 @@
 		default:
 			if (apropos)
 				usage_whatapro();
+			else if (catman)
+				usage_catman();
+			else if (makewhatishere)
+				usage_makewhatis();
 			else
 				usage_man();
 		}
@@ -690,8 +707,10 @@
 	char		s[MAXNAMELEN];
 	int		i;
 
-	if ((fp = fopen(whatpath, "r")) == NULL)
+	if ((fp = fopen(whatpath, "r")) == NULL) {
+		perror(whatpath);
 		return;
+	}
 
 	DPRINTF("-- Found %s: %s\n", WHATIS, whatpath);
 
@@ -1564,4 +1583,21 @@
 	    whatis ? "whatis" : "apropos");
 
 	exit(1);
+}
+
+static void
+usage_catman(void)
+{
+	(void) fprintf(stderr, gettext(
+"usage: catman [-M path] [-w]\n"));
+
+	exit(1);
+}
+
+static void
+usage_makewhatis(void)
+{
+	(void) fprintf(stderr, gettext("usage: makewhatis\n"));
+
+	exit(1);
 }
